//+------------------------------------------------------------------+
//|                                                   PlanetLine.mq4 |
//|                                                            lifer |
//|                                                            lifer |
//+------------------------------------------------------------------+
#property copyright "lifer"
#property link      "lifer"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Red
#property indicator_color3 Red
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Blue
#property indicator_color8 Red
//---- input parameters
extern string    NatalDate = "0";

extern int       Body = 1;
extern int       iflag = 0;
extern int       Body2 = -1;

extern double    OctavaAdd = 0;
extern double    GradusAdd = 0;

extern int    FutureBars=100;
extern int    Shift0 = 0; 
extern int    BarLimits = 600;

extern double K = 10000.0;
//extern double MultipleGradus = 1.0;
extern double Circle360 = 360.0;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexEmptyValue(0,0.0);
   SetIndexShift(0,FutureBars);   
   SetIndexStyle(0,DRAW_SECTION,STYLE_DASH,1,Magenta);
   
   SetIndexStyle(1,DRAW_SECTION);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexEmptyValue(1,0.0);
   SetIndexShift(1,FutureBars);   
   SetIndexStyle(1,DRAW_SECTION,STYLE_DASH,1,Coral);
   
   SetIndexStyle(2,DRAW_SECTION);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexEmptyValue(2,0.0);
   SetIndexShift(2,FutureBars);   
   SetIndexStyle(2,DRAW_SECTION,STYLE_DASH,1,LightGreen);
   
   SetIndexStyle(3,DRAW_SECTION);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexEmptyValue(3,0.0);
   SetIndexShift(3,FutureBars);   
   SetIndexStyle(3,DRAW_SECTION,STYLE_DASH,1,IndianRed);
   
   SetIndexStyle(4,DRAW_SECTION);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexEmptyValue(4,0.0);
   SetIndexShift(4,FutureBars);   
   SetIndexStyle(4,DRAW_SECTION,STYLE_DASH,1,Red);
   
   SetIndexStyle(5,DRAW_SECTION);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexEmptyValue(5,0.0);
   SetIndexShift(5,FutureBars);   
   SetIndexStyle(5,DRAW_SECTION,STYLE_DASH,1,LightBlue);
   
   SetIndexStyle(6,DRAW_SECTION);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexEmptyValue(6,0.0);
   SetIndexShift(6,FutureBars);   
   SetIndexStyle(6,DRAW_SECTION,STYLE_DASH,1,Gray);
   
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,161);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexEmptyValue(7,0.0);
   SetIndexShift(7,FutureBars);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
bool trigger = false;
#include <astro_func.mq4>
#include <astro_periods.mq4>
#include <find_shift.mq4>
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   // 
   if(trigger == true) { return(0); }
   trigger = true;      
   Comment("");
   
   // initial point
   int initial_shift;
   if(NatalDate == "0")
   {
     initial_shift = MathMin(Bars-1,BarLimits-FutureBars);
   }
   else
   {
     initial_shift = find_shift(NatalDate);
   }
   
   string comment = astro_bodyname(Body);
   if(Body2 != -1) comment = comment + "+"+astro_bodyname(Body2);
   Comment(comment);
   
   
   
   int shift_end = MathMax(initial_shift - BarLimits, Shift0-FutureBars);
   
      double price = Open[initial_shift]*K;
      double gradus = MathMod(price,Circle360);
      double octava = (price - gradus)/Circle360;
      
      double longtitude = get_astro_gradus(initial_shift, Body, iflag);
      if(Body2 != -1) longtitude = (longtitude + get_astro_gradus(initial_shift, Body2, iflag))/2.0;
      
      double price0 = octava*Circle360 + longtitude;
      double price1 = price0 + Circle360;
      double price2 = price0 - Circle360;
      
      double addon = 0;
      if(MathAbs(price1-price) < MathAbs(price0-price))
      {
        octava = octava + 1.0;
      }
      else
      if(MathAbs(price2-price) < MathAbs(price0-price))
      {
        octava = octava - 1.0;
      }
      
      octava = octava + OctavaAdd;
      octava = octava + GradusAdd/Circle360;
   
   for(int shift = initial_shift; shift >= shift_end; shift--)
   {
      //
      longtitude = get_astro_gradus(shift, Body, iflag);
      if(Body2 != -1) longtitude = (longtitude + get_astro_gradus(initial_shift, Body2, iflag))/2.0;
      
      price0 = octava*Circle360 + longtitude;
      price1 = price0 + Circle360;
      price2 = price0 - Circle360;
      
      price0 = price0/K;
      price1 = price1/K;
      price2 = price2/K;
      
      
      ExtMapBuffer1[shift + FutureBars] = price0;
      ExtMapBuffer2[shift + FutureBars] = price1;
      ExtMapBuffer3[shift + FutureBars] = price2;
      
   }
   
   
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+




